"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Sample(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.metadata.Sample": opencb_2_9_3.Sample,
        }

    __slots__ = [
        "id",
        "annotations",
    ]

    def __init__(
        self,
        id,
        annotations=dict,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.Sample model.

        :param id:
            Sample identifier
        :type id: str
        :param annotations:
            Sample annotations stored in a map of attributes according to the
            format:          attribute_name[:x] where x defines the
            attribute type, its valid values are:              n for
            numeric (i = integer, f = float)              s for string
            b for boolean           e.g. age:n, population:s,
            height:n, weight, risk factors, secondary conditions,...
        :type annotations: dict[str, str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
